#include "diskfile.h"
#include <assert.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>


CDiskFile::CDiskFile(char* fileName, long pageSize)
    : m_pageSize(pageSize),
    m_nextPage(0),
    m_numOfPages(0)/*,
    m_fileName(fileName)*/
{
  strcpy(m_fileName, fileName);
//   string dataFileName(fileName);
  // dataFileName += ".dat";
  
//   m_dataFile.open(dataFileName.c_str(), ios::out | ios::binary | ios::trunc);

//   m_dataFile.open(fileName, ios::out | ios::binary | ios::trunc);

//   cerr <<"Index File : " << dataFileName.c_str() << endl;
  
//   assert( m_dataFile.is_open());

  // create buffer
  m_buf = new char[m_pageSize];
  bzero(m_buf, m_pageSize);
}

CDiskFile::CDiskFile(char* fileName)
    : m_nextPage(0),
    m_numOfPages(0)/*,
    m_fileName(fileName)*/
{
  strcpy(m_fileName, fileName);
//   string dataFileName(fileName);
  // dataFileName += ".dat";

//   m_dataFile.open(dataFileName.c_str(), ios::in | ios::binary);
  m_dataFile.open(fileName, ios::in | ios::binary);

  assert(m_dataFile.is_open());

  // page size is on the second place
  m_dataFile.read((char*)&m_pageSize, sizeof(long));

  // create buffer
  m_buf = new char[m_pageSize];
  bzero(m_buf, m_pageSize);

  m_dataFile.close();
}

CDiskFile::~CDiskFile(void)
{
//   m_dataFile.close();
  delete[] m_buf;
}

void CDiskFile::readEntry(long id, char** data)
{
//   m_dataFile.open(m_fileName, ios::in | ios::binary);  
//   assert( m_dataFile.is_open());
  
  m_dataFile.seekg(id*m_pageSize, ios::beg);
  // m_dataFile.seekg((id - m_nextPage) * m_pageSize, ios::cur);

  *data = new char[m_pageSize];
  m_dataFile.read( *data, m_pageSize );
  // memcpy( *data, m_buf, length);
  // m_nextPage=id + 1;
  
//   m_dataFile.close();
}

void CDiskFile::writeEntry(long id,  long length,  char* data)
{
//   m_dataFile.open(m_fileName, ios::out | ios::binary | ios::trunc);
//   assert(m_dataFile.is_open());
  
  m_numOfPages ++;
  // m_dataFile.seekp((id - m_nextPage) * m_pageSize, ios::cur);
  // m_dataFile.write((char*)&len , sizeof(long));
  memset( m_buf, 0 , m_pageSize );
  memcpy( m_buf, data, length);
  m_dataFile.write( m_buf, m_pageSize );
  // m_nextPage = id + 1;
  
//   m_dataFile.close();
}

void CDiskFile::open(bool isWrite)
{
  if (isWrite)
  {
    m_dataFile.open(m_fileName, ios::out | ios::binary | ios::trunc);
  }
  else
  {
    m_dataFile.open(m_fileName, ios::in | ios::binary);
  }
  assert(m_dataFile.is_open());
}

void CDiskFile::close()
{
  m_dataFile.close();
}




