#ifndef DISKFILE_H
#define DISKFILE_H

#include <fstream>
#include <string>
#include <cstdlib>
#include <vector>

using namespace std;


/*
  a disk file consists of lots of equal size pages.  the page id is the
  indicator of that page.  page id starts from 0.  if page id is -1,
  that page is not in the disk now, i.e., a new page.
*/
class CDiskFile
{
private:  
  char m_fileName[128];

  fstream m_dataFile;   // m_dataFile is for the data

  long m_pageSize;    // the page size

  long m_numOfPages;    // number of all pages in m_dataFile

  long m_nextPage;    // id of the next page to read/write in m_dataFile

  vector<long> m_emptyPages;  // all deleted page ids

  char* m_buf;  // a buffer

public:
  // create a new file
  CDiskFile(char* fileName, long pageSize);

  // open a file
  CDiskFile(char* fileName);

  virtual ~CDiskFile(void);

  void readEntry(long id,  char** data);
  void writeEntry(long id, long length, char* data);
  
  void open(bool isWrite);
  void close();
  
};

#endif
