#ifndef HEAP_H
#define HEAP_H


#include <iostream>

#include "heapnode.h"

using namespace std;

class CHeapNode;

class CHeap
{
private:
	// the heap starts from m_root. the first data item is m_root's left child
	CHeapNode* m_root;

	CHeapNode* m_lastNode;

	long m_heapSize;

public:
	CHeap(void);
	~CHeap(void);

	CHeapNode* getRoot(void) const;

	long getHeapSize(void) const;

	CHeapNode* top(void) const;
	void pop(void);

	// clear() just deletes all nodes except the root node from the heap.
	void clear(void);

	void insertNode(double key, void* data);
	void deleteNode(CHeapNode* pNode);

	void dump(ostream& os, CHeapNode* pNode, bool details) const;

private:
	// compare the keys of parent and child to determine whether they will
	// be swapped.  'true' means to swapping is needed.
	bool isWrongPos(CHeapNode* parent, CHeapNode* child);

	void heapify(CHeapNode* pNode, bool upwards);

	CHeapNode* getInsertPoint(void);
};

#endif
