#ifndef HEAPNODE_H
#define HEAPNODE_H

#include <iostream>
#include "node.h"

using namespace std;

class CHeapNode
{
public:
  double m_key;
//   CNode* m_data;
  void* m_data;

    CHeapNode* m_parent;
    CHeapNode* m_leftChild;
    CHeapNode* m_rightChild;

    CHeapNode* m_previous;
    CHeapNode* m_next;

public:
	CHeapNode(void);
// 	CHeapNode(double key, CNode* data);
  CHeapNode(double key, void* data);
	~CHeapNode(void);

	double getKey(void) const;
//   CNode* getData(void);
  void* getData(void);

	CHeapNode* getParent(void) const;
	CHeapNode* getLeftChild(void) const;
	CHeapNode* getRightChild(void) const;

	CHeapNode* getPrevious(void) const;
	CHeapNode* getNext(void) const;

	bool isLeftChild(void) const;

	void setParent(CHeapNode* pNode);
	void setLeftChild(CHeapNode* pNode);
	void setRightChild(CHeapNode* pNode);

	void setPrevious(CHeapNode* pNode);
	void setNext(CHeapNode* pNode);

	void swapData(CHeapNode* pNode);

	void dump(ostream& os, long level, bool details) const;

	// -1: currentKey < key; 0: currentKey = key; 1: currentKey > key
	long compareKey(double key) const;
};

inline
long CHeapNode::compareKey(double key) const
{
	double epsilon = 1e-10;

	if(key - m_key > epsilon)
	{
		return -1;
	}
	else if(m_key - key > epsilon)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

#endif
