#ifndef MYSTACK_H
#define MYSTACK_H

#include <cstdlib>

using namespace std;

template<class T>
class CStack
{
  private:
    struct Link
    {
      T data;
      Link* next;
      Link(T dat, Link* nxt)
        :data(dat), next(nxt)
      {}
    }* m_head;
    
  public:
    CStack(void)  
      :m_head(NULL)
    {
    }
    
    ~CStack(void)
    {
      while (m_head != NULL)
      {
        Link* oldHead = m_head;
        m_head = oldHead->next;
        delete oldHead;
      }
    }
    
    T top(void)
    {
      if (m_head == NULL)
      {
        return 0;
      }
      else
      {
        return m_head->data;
      }
    }
    
    void pop(void)
    {
      Link* oldHead = m_head;
      m_head = oldHead->next;
      delete oldHead;
    }
    
    void push(T dat)
    {
      m_head = new Link(dat, m_head);
    }
    
    bool empty(void)
    {
      return (m_head == NULL);
    }
};

#endif
