# synthetic 

alg_c=6
s=1.3
dfile="data/io_10"
epsfile="../../fig/fig1_a.eps"

height=555

alg1=SIX
alg2=TPL
alg3=FINCH
alg4=INF
alg5=SLICE

echo "$epsfile"

#data set

cmd="
set term postscript enhanced eps 32
set output \"${epsfile}\"


set tmargin 0.2
set rmargin 0.3
set lmargin 5.3
set bmargin 1.0

set xrange [ 0: 6]
set yrange [ 0: \"${height}\"]

set ytics offset 0.8,0 font \"Helvetica-Bold, 30\"

#set ytics ( \"0\" 0,\"10K\" 10000,  \"20K\" 20000, \"30K\" 30000, \"40K\" 40000 , \"50K\" 50000, \"60K\" 60000 , \"70K\" 70000)

set xtics font \"Helvetica-Bold, 32\"
set xtics scale 0 offset 0, -1.2 font\"Helvetica-Bold, 28\" ( \"d=10ms\" 3)

unset xtics

set x2tics  axis   scale 0 offset 0.0, 0.4 font\"Helvetica-Bold, 28\"  (\"${alg1}\" 1,\"${alg2}\" 2,\"${alg3}\" 3,\"${alg4}\" 4,\"${alg5}\" 5)


#set x2tics  axis   scale 0 offset 0.6, 0.8 font\"Helvetica-Bold, 16\"( \"SIX\" 0.0,\"FINCH_{OLD}\" '$s' , \"FINCH\" 2*'$s' , \"INF\" 3*'$s' ,\"SLICE\" 4*'$s' ,\"\" 5*'$s' , \"SIX\"1+6*'$s', \"FINCH_{OLD}\" 1+7*'$s' ,\"FINCH\" 1+8*'$s' ,\"INF\" 1+9*'$s' ,\"SLICE\" 1+10*'$s' ,\"\" 1+11*'$s' , \"SIX\"2.2+12*'$s',\"FINCH_{OLD}\" 2.2+13*'$s' ,\"FINCH\" 2.2+14*'$s' ,\"INF\" 2.2+15*'$s'  ,\"SLICE\" 2.2+16*'$s' ,\"\" 2.2+17*'$s' ,\"SIX\"3.4+18*'$s',\"FINCH_{OLD}\" 3.4+19*'$s' ,\"FINCH\" 3.4+20*'$s' ,\"INF\" 3.4+21*'$s',\"SLICE\" 3.4+22*'$s' ,\"\" 3.4+23*'$s'  )


#set x2tics  axis  rotate  scale 0 offset 1.2, -0.8  font ',18'( \"     SIX\" 0.0 , \"     INF\" '$s' , \"SLICE\" 2*'$s' ,\"     SIX\" 3.1+3*'$s' ,\"     INF\" 3.1+4*'$s' ,\"SLICE\" 3.1+5*'$s' ,\"     SIX\" 6.2+6*'$s' ,\"     INF\" 6.2+7*'$s' ,\"SLICE\" 6.2+8*'$s'  ,\"     SIX\" 9.3+9*'$s' ,\"     INF\" 9.3+10*'$s' ,\"SLICE\" 9.3+11*'$s' )

set ylabel offset 2.6, 0 \"Total Cost (ms)\"   font  \"Helvetica-Bold, 32\" 


#set label 1 \" the percentage of the I/O cost \" at 0.5, 32 font \"Helvetica-Italic, 12\"



set key  right   font ',28' spacing 0.7
set boxwidth 0.8
set size 1, 0.9

plot '$dfile' using ((\$1)-1)*${alg_c}+1:(\$4)  title \"CPU Time\" with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+1:(\$2)  title \"I/O Time\" with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+1:(\$4+0.15*\"${height}\"):(\$4) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+2:(\$7)   notitle with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+2:(\$5)   notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+2:(\$7+0.15*\"${height}\"):(\$7) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+3:(\$10)  notitle with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+3:(\$8)   notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+3:(\$10+0.15*\"${height}\"):(\$10) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+4:(\$13)  notitle with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+4:(\$11)  notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+4:(\$13+0.15*\"${height}\"):(\$13) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+5:(\$16)  notitle with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+5:(\$14)  notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+5:(\$16+0.15*\"${height}\"):(\$16) notitle with labels rotate font \"Helvetica,28\"
    
"

echo "$cmd" | gnuplot

#gv "$epsfile"


