# synthetic 

alg_c=9
s=1.3
dfile="data/io_bound"
epsfile="../../fig/relative_u_large_f_io_bound_f.eps"

height=17.5

alg1=SIX
alg2=TPL
alg3=TPL++
alg4=FINCH
#alg5=FINCH++
alg5=INF
alg6=SLICE
alg7=LB

echo "$epsfile"

#data set

cmd="
set term postscript enhanced eps 32
set output \"${epsfile}\"


set tmargin 0.1
set rmargin 0.5
set lmargin 4.5
set bmargin 3.1

set xrange [ -1: 36  ]
set yrange [ 0: \"${height}\"]
set ytics offset 0.4,0 font \"Helvetica-Bold, 32\"
#set ytics ( \"0\" 0, \"20K\" 20000, \"40K\" 40000,\"60K\" 60000,\"80K\" 80000,\"100K\" 100000, \"120K\" 120000,\"140K\" 140000,\"160K\" 160000)

set xtics font \"Helvetica-Bold, 32\"
set xtics scale 0 offset 2, -1.2 font\"Helvetica-Bold, 28\" ( \"1000\" 3,  \"10000\" 12, \"100000\" 21, \"1000000\" 30 )

set x2tics  axis  rotate by -45 scale 0 offset 0.0, 0.8 font\"Helvetica-Bold, 22\"  (\"${alg1}\" 1,\"${alg2}\" 2,\"${alg3}\" 3,\"${alg4}\" 4,\"${alg5}\" 5,\"${alg6}\" 6 ,\"${alg7}\" 7 ,\"${alg8}\" 8 ,\"${alg1}\" 10,\"${alg2}\" 11,\"${alg3}\" 12,\"${alg4}\" 13,\"${alg5}\" 14,\"${alg6}\" 15 ,\"${alg7}\" 16 ,\"${alg8}\" 17,\"${alg1}\" 19,\"${alg2}\" 20,\"${alg3}\" 21,\"${alg4}\" 22,\"${alg5}\" 23,\"${alg6}\" 24 ,\"${alg7}\" 25,\"${alg8}\" 26,\"${alg1}\" 28,\"${alg2}\" 29,\"${alg3}\" 30,\"${alg4}\" 31,\"${alg5}\" 32,\"${alg6}\" 33 ,\"${alg7}\" 34 , \"${alg8}\" 35,\"${alg1}\" 37,\"${alg2}\" 38,\"${alg3}\" 39,\"${alg4}\" 40,\"${alg5}\" 41,\"${alg6}\" 42 ,\"${alg7}\" 43,\"${alg8}\" 44, \"${alg1}\" 46,\"${alg2}\" 47,\"${alg3}\" 48,\"${alg4}\" 49,\"${alg5}\" 50,\"${alg6}\" 51 ,\"${alg7}\" 52 ,\"${alg8}\" 53)


#set x2tics  axis  rotate by -45 scale 0 offset 0.6, 0.8 font\"Helvetica-Bold, 16\"( \"SIX\" 0.0,\"FINCH_{OLD}\" '$s' , \"FINCH\" 2*'$s' , \"INF\" 3*'$s' ,\"SLICE\" 4*'$s' ,\"\" 5*'$s' , \"SIX\"1+6*'$s', \"FINCH_{OLD}\" 1+7*'$s' ,\"FINCH\" 1+8*'$s' ,\"INF\" 1+9*'$s' ,\"SLICE\" 1+10*'$s' ,\"\" 1+11*'$s' , \"SIX\"2.2+12*'$s',\"FINCH_{OLD}\" 2.2+13*'$s' ,\"FINCH\" 2.2+14*'$s' ,\"INF\" 2.2+15*'$s'  ,\"SLICE\" 2.2+16*'$s' ,\"\" 2.2+17*'$s' ,\"SIX\"3.4+18*'$s',\"FINCH_{OLD}\" 3.4+19*'$s' ,\"FINCH\" 3.4+20*'$s' ,\"INF\" 3.4+21*'$s',\"SLICE\" 3.4+22*'$s' ,\"\" 3.4+23*'$s'  )


#set x2tics  axis  rotate  scale 0 offset 1.2, -0.8  font ',18'( \"     SIX\" 0.0 , \"     INF\" '$s' , \"SLICE\" 2*'$s' ,\"     SIX\" 3.1+3*'$s' ,\"     INF\" 3.1+4*'$s' ,\"SLICE\" 3.1+5*'$s' ,\"     SIX\" 6.2+6*'$s' ,\"     INF\" 6.2+7*'$s' ,\"SLICE\" 6.2+8*'$s'  ,\"     SIX\" 9.3+9*'$s' ,\"     INF\" 9.3+10*'$s' ,\"SLICE\" 9.3+11*'$s' )

set ylabel offset 2.3, 0 \"# IO\"   font  \"Helvetica-Bold, 32\" 
set xlabel offset 0,-0.2 \"number of users\"   font  \"Helvetica-Bold, 32\" 

#set label 1 \" the percentage of the I/O cost \" at 0.5, 32 font \"Helvetica-Italic, 12\"



set key  left   font ',28' spacing 0.7
set boxwidth 0.8
set size 2, 1

plot '$dfile' using ((\$1)-1)*${alg_c}+1:(\$2)  title \"Facility R*-tree\" with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+1:(\$2+0.12*\"${height}\"):(\$2) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+2:(\$5)   notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+2:(\$5+0.12*\"${height}\"):(\$5) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+3:(\$8)   notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+3:(\$8+0.12*\"${height}\"):(\$8) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+4:(\$11)  notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+4:(\$11+0.12*\"${height}\"):(\$11) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+5:(\$14)  notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+5:(\$14+0.12*\"${height}\"):(\$14) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+6:(\$17)  notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+6:(\$17+0.12*\"${height}\"):(\$17) notitle with labels rotate font \"Helvetica,28\",\
     '$dfile' using ((\$1)-1)*${alg_c}+7:(\$20)  notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+7:(\$20+0.12*\"${height}\"):(\$20) notitle with labels rotate font \"Helvetica,28\"
"

echo "$cmd" | gnuplot

gv "$epsfile"


