# synthetic 

alg_c=5
s=1.3
dfile="data/io_tpl"
epsfile="../../fig/fig6_a.eps"

height=53

alg1=TPL
alg2=OPT1
alg3=OPT2
alg4=TPL++
#alg5=FINCH++
#alg6=INF
#alg7=SLICE

echo "$epsfile"

#data set

cmd="
set term postscript enhanced eps 32
set output \"${epsfile}\"


set tmargin 0.2
set rmargin 0.5
set lmargin 3.6
set bmargin 2.8

set xrange [ -1:  ]
set yrange [ 0: \"${height}\"]

set ytics offset 0.8,0 font \"Helvetica-Bold, 30\"

#set ytics ( \"0\" 0,\"10K\" 10000,  \"20K\" 20000, \"30K\" 30000, \"40K\" 40000 , \"50K\" 50000, \"60K\" 60000 , \"70K\" 70000)

set xtics font \"Helvetica-Bold, 32\"
set xtics scale 0 offset 1, -0.6 font\"Helvetica-Bold, 28\" ( \"2\" 2,  \"5\" 7, \"10\" 12, \"15\" 17, \"20\" 22, \"25\" 27)

set x2tics  axis  rotate by -45 scale 0 offset 0.0, 0.8 font\"Helvetica-Bold, 16\"  (\"${alg1}\" 1,\"${alg2}\" 2,\"${alg3}\" 3,\"${alg4}\" 4,\"${alg1}\" 6,\"${alg2}\" 7,\"${alg3}\" 8,\"${alg4}\" 9,\"${alg1}\" 11,\"${alg2}\" 12,\"${alg3}\" 13,\"${alg4}\" 14,\"${alg1}\" 16,\"${alg2}\" 17,\"${alg3}\" 18,\"${alg4}\" 19,\"${alg1}\" 21,\"${alg2}\" 22,\"${alg3}\" 23,\"${alg4}\" 24,\"${alg1}\" 26,\"${alg2}\" 27,\"${alg3}\" 28,\"${alg4}\" 29)


#set x2tics  axis  rotate by -45 scale 0 offset 0.6, 0.8 font\"Helvetica-Bold, 28\"( \"SIX\" 0.0,\"FINCH_{OLD}\" '$s' , \"FINCH\" 2*'$s' , \"INF\" 3*'$s' ,\"SLICE\" 4*'$s' ,\"\" 5*'$s' , \"SIX\"1+6*'$s', \"FINCH_{OLD}\" 1+7*'$s' ,\"FINCH\" 1+8*'$s' ,\"INF\" 1+9*'$s' ,\"SLICE\" 1+10*'$s' ,\"\" 1+11*'$s' , \"SIX\"2.2+12*'$s',\"FINCH_{OLD}\" 2.2+13*'$s' ,\"FINCH\" 2.2+14*'$s' ,\"INF\" 2.2+15*'$s'  ,\"SLICE\" 2.2+16*'$s' ,\"\" 2.2+17*'$s' ,\"SIX\"3.4+18*'$s',\"FINCH_{OLD}\" 3.4+19*'$s' ,\"FINCH\" 3.4+20*'$s' ,\"INF\" 3.4+21*'$s',\"SLICE\" 3.4+22*'$s' ,\"\" 3.4+23*'$s'  )


#set x2tics  axis  rotate  scale 0 offset 1.2, -0.8  font ',18'( \"     SIX\" 0.0 , \"     INF\" '$s' , \"SLICE\" 2*'$s' ,\"     SIX\" 3.1+3*'$s' ,\"     INF\" 3.1+4*'$s' ,\"SLICE\" 3.1+5*'$s' ,\"     SIX\" 6.2+6*'$s' ,\"     INF\" 6.2+7*'$s' ,\"SLICE\" 6.2+8*'$s'  ,\"     SIX\" 9.3+9*'$s' ,\"     INF\" 9.3+10*'$s' ,\"SLICE\" 9.3+11*'$s' )

set ylabel offset 2.9, 0 \"# IO\"   font  \"Helvetica-Bold, 32\" 
set xlabel offset 1, 0 \"{/Helvetica-Bold-Oblique k}\"   font  \"Helvetica-Bold, 34\" 


#set label 1 \" the percentage of the I/O cost \" at 0.5, 32 font \"Helvetica-Italic, 12\"



set key  left   font ',28' spacing 0.7
set boxwidth 0.8
set size 1, 0.9

plot '$dfile' using ((\$1)-1)*${alg_c}+1:(\$4)  title \"Verification\" with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+1:(\$2)  title \"Filtering\" with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+1:(\$4+0.12*\"${height}\"):(\$4) notitle with labels rotate font \"Helvetica,20\",\
     '$dfile' using ((\$1)-1)*${alg_c}+2:(\$7)   notitle with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+2:(\$5)   notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+2:(\$7+0.12*\"${height}\"):(\$7) notitle with labels rotate font \"Helvetica,20\",\
      '$dfile' using ((\$1)-1)*${alg_c}+3:(\$10)   notitle with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+3:(\$8)   notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+3:(\$10+0.12*\"${height}\"):(\$10) notitle with labels rotate font \"Helvetica,20\",\
     '$dfile' using ((\$1)-1)*${alg_c}+4:(\$13)   notitle with boxes fill pattern 0 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+4:(\$11)   notitle with boxes fill pattern 3 lt 1 lw 2,\
     '$dfile' using ((\$1)-1)*${alg_c}+4:(\$13+0.12*\"${height}\"):(\$13) notitle with labels rotate font \"Helvetica,20\"
"

echo "$cmd" | gnuplot

#gv "$epsfile"


